/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.15
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include "mcc_generated_files/mcc.h"
//VARIABLES______________________________________________________________
uint8_t rxBuf[64];
uint8_t indx;
uint16_t adcValue;

//FUNCTIONS______________________________________________________________
//Read Buffer------------------------------------------------------------
void readBuffer (void)
{indx=0;
    if (EUSART_DataReady)
    { do{ rxBuf[indx++]=EUSART_Read ();}
      while (EUSART_DataReady);}
}
// Read ADC input--------------------------------------------------------
    void readADCvalue(void)
    {adcValue=ADC_GetConversion(POT);
     printf("Analog Port is <---- %d\r\n",adcValue);
    }
// port 1 status --------------------------------------------------------
    void Port1Status (void)
    {if (input1_PORT==1){printf("Port 1 <---- 'high'\n");}
     else {printf("Port 1 <---- 'low'\n");}
    }
// port 2 status --------------------------------------------------------
    void Port2Status (void)
    {if (input2_PORT==1) {printf("Port 2 <---- 'high'\n");}
     else {printf("Port 2 <---- 'low'\n)");}
    }
//Port A Status ---------------------------------------------------------
    void PortAStatus (void)
    { if (outputA_PORT==1){printf("Port A is set ---->'on'\n");}
      else {printf("Port A is set ---->'off'\n");}
    }
//Port B Status --------------------------------------------------------
    void PortBStatus (void)
    { if (outputB_PORT==1){printf("Port B is set ---->'on'\n");}
      else {printf("Port B is set ---->'off'\n");}
    }
//Alldata --------------------------------------------------------------
    void Alldata(void)
    {printf("Hello \n\r"); 
    readADCvalue();
    Port1Status();
    Port2Status();
    PortAStatus();
    PortBStatus();
    }
//Read and respond to instructions, echo back status --------------------
    void ReadRespond(void)
{if (EUSART_DataReady)
  {do
     {

      rxBuf[0]=EUSART_Read();
      if(rxBuf[0]=='~'){Alldata();}
      if(rxBuf[0]=='3'){ readADCvalue ();}
      if(rxBuf[0]=='A'){outputA_LAT=1;printf("Port A is ----> 'on'\n");}
      if(rxBuf[0]=='a'){outputA_LAT=0;printf("Port A is ----> 'off'\n");}
      if(rxBuf[0]=='B'){outputB_LAT=1;printf("Port B is ----> 'on'\n");}
      if(rxBuf[0]=='b'){outputB_LAT=0;printf("Port B is ----> 'off'\n");}
      if(rxBuf[0]=='1'){Port1Status();}
      if (rxBuf[0]=='2'){Port2Status ();}
     }
       while (EUSART_DataReady);
   }
}
//end of functions section____________________________________
/*
                         Main application
 */
void main(void)
 {
    SYSTEM_Initialize();                // initialize the device
    INTERRUPT_GlobalInterruptEnable();  // Enable the Global Interrupts
    INTERRUPT_PeripheralInterruptEnable();// Enable Peripheral Interrupts

    //  setup RN4020--------
    indx=0;
    CMD_SetLow ();              // set 4020 in command mode
    WAKEHW_SetHigh();           // wake 4020 from hibernation
    WAKESW_SetLow();            // wake 4020 from deep sleep
    __delay_ms(100);
    WAKESW_SetHigh();
    __delay_ms(2000); 
    printf("S-,BLUE_\r\n");     // name device "Blue"
   __delay_ms(500);
    printf("SR,32200000\r\n");// set 4020- start advertising "2000 0000"
    __delay_ms(500);          // set 4020- enable UART "1000 0000"
                              // set 4020- UART flow control "0200 0000"
                           // set 4020- enable remote control "0020 0000"
    printf("SP,7\r\n");         // set transmission power = 7.5dBm (high) 
    __delay_ms(500);
    printf("R,1\r\n");          // reboot - changes are active
    __delay_ms(1000);
    CMD_SetHigh ();             // exit command mode
    printf("A\r\n");            // start advertising
    readBuffer();               // empty the buffer

      // program loop -------
    do
        {
            ReadRespond();    // read from the buffer,perform instruction
                             // and transmit back status to Iphone
        }
    while(1);
}
/**
 End of File
 */	
